<?php

namespace Teknisa\CADCTB\Controllers;

use Teknisa\CADCTB\Services\Ger17300InformativoComposicaoCustosService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request\DataSet as Data;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\CADCTB\Controllers\TeknisaCrud;
use Teknisa\CADCTB\Controllers\EntityManager;
use Teknisa\Libs\Util\Environment;

class Ger17300InformativoComposicaoCustosController{
    
    protected $ger17300InformativoComposicaoCustosService;
    protected $entityManager;
    protected $connection;
    
    public function __construct(\Doctrine\ORM\EntityManager $entityManager, Environment $environment, Ger17300InformativoComposicaoCustosService $ger17300InformativoComposicaoCustosService){
        $this->ger17300InformativoComposicaoCustosService = $ger17300InformativoComposicaoCustosService;
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
    }
    
    public function salvarImportacaoL210(Row $row, Response $response) {
        $row = $row->getRow();
        $this->entityManager->beginTransaction();
        try{
            
            $this->ger17300InformativoComposicaoCustosService->salvarImportacaoL210($row);
            $this->entityManager->commit();
        }
        catch (\Exception $e) {
            $this->entityManager->rollback();
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

}