<?php

namespace Teknisa\CADCTB\Services;

use Teknisa\Model\Geral\Entities\Prodfili;
use Teknisa\CADCTB\Factories\Ctb27200RegistroAjustePeriodoBaseFactory;
use Teknisa\Libs\Util\Environment;

class Ctb27200RegistroAjustePeriodoBaseService {
    
    public $entityManager;
    protected $environment;
    protected $nrorg;
    protected $Ctb27200Factory;
    
    public function __construct($entityManager, Environment $environment, Ctb27200RegistroAjustePeriodoBaseFactory $factory, $newCode) {
        $this->entityManager    = $entityManager;
        $this->environment      = $environment;
        $this->Ctb27200Factory  = $factory;
        $this->newCode = $newCode; 
    }
    
    public function saveRegistro($row){
        try{
            if($row['__is_new']){
                $row['NRSEQLALURA'] = $this->newCode->getCodeByTableName('LALURPARTEA', $this->nrorg, 1, 0, true);
            
                $this->Ctb27200Factory->acmInsertLancParteA($row); 
            } else {
                $this->Ctb27200Factory->acmUpdateLancParteA($row);
            }

        } catch (\Exception $e) {
            throw $e;
        }
    }
    public function ckcAtualizaSaldoParteB($row){
        $adqDadosParteB = $this->adqDadosParteB($row);
        //roda procedure do reflexo na parte b caso precise
        if(!empty($adqDadosParteB)){
            $this->atualizaSaldoParteB($adqDadosParteB['CDEMPRESA'], '', 'N', $adqDadosParteB['CDCONTCTBL']);
        }
    }
    
    public function saveParteA($row){
        try{
            $row['VRLANCAMENT'] = 0;
            $row['NRORG'] = $nrorg = $this->environment->getNrOrgTrab();
            $row['NRSEQCONTLALURA'] = $this->newCode->getCodeByTableName('CONTASLALURA', $this->nrorg, 1, 0, true);
            $row['VRCDCONTCTBL'] = -1 * $row['VRLANCAMENT'];
            $this->Ctb27200Factory->InsertContasLalur($row);
            $this->ckcAtualizaSaldoParteB($row);
/*            if($adqDadosParteA['IDTIPOLANC'] != 'A'){
                $pVRDEBITO = (float) $adqDadosParteA['VRLANCAMENT'];
                $pVRCREDITO = 0;
            }
            else {
                $pVRDEBITO =  0;
                $pVRCREDITO = (float) $adqDadosParteA['VRLANCAMENT'];
            }
*/
            
           // $this->Ctb27200Factory->InsertContasLalur($row);
            //$row['IDRELACAO'] = $adqDadosParteA['IDRELACAO'];
            //$row['CDCONTCTBLB'] = $adqDadosParteA['CDCONTCTBLB'];
            //$acmUpdateLancParteA = $this->Ctb27200Factory->acmUpdateLancParteA($row); 
           // $adqDadosParteB = $this->adqDadosParteB($row);
            //$adqDadosParteA = $this->adqDadosParteA($row);
            
            //PARTE B (EU ACHO) $this->Ctb27200Factory->execSaldoLalurParteB($row['CDEMPRESA'], $row['CDCONTCTBL']);
            
            //$row['VRCDCONTCTBL'] = -1 * $row['VRLANCAMENT'];
            //$acmUpdateContasLancParteA = $this->Ctb27200Factory->acmUpdateContasLancParteA($row);
            
            // VANISHED $row['NRSEQLANC'] = $this->Ctb27200Factory->getNrseqLanc($row); 
            //$row['NRSEQLANCLALURA'] = $this->Ctb27200Factory->getNrseqLanclalura($row); 
            //var_dump($InsertContasLalur); die();//$row['CDEMPRESA'], $row['NRLANCCONT'], $row['NRSEQLANC'], $row['NRSEQCONTLALURA'], $row['NRSEQLANCLALURA']);die();
            //$this->Ctb27200Factory->acmInsertLancContas($row); 
            
            return array('NRSEQCONTLALURA' => $row['NRSEQCONTLALURA']);
            
		} catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function saveParteB($row){
        try{
            $row['NRORG'] = $nrorg = $this->environment->getNrOrgTrab();
            $this->atualizaSaldoParteB($row['CDEMPRESA'], '', 'N', $row['CDCONTCTBL']);
            $adqDadosParteB = $this->adqDadosParteB($row);
            $adqDadosParteA = $this->adqDadosParteA($row);
            $row['CDCONTCTBLB'] = $adqDadosParteA['CDCONTCTBLB'];
            if($adqDadosParteA['IDTIPOLANC'] != 'A'){
                $pVRDEBITO = $adqDadosParteA['VRLANCAMENT'];
                $pVRCREDITO = 0;
            }
            else {
                $pVRDEBITO =  0;
                $pVRCREDITO = $adqDadosParteA['VRLANCAMENT'];
            }
            if(!empty($adqDadosParteB)){
                $acmDelLalurParteB = $this->Ctb27200Factory->getAcmDelLalurParteB($row);
                $row['NRSEQLALURB'] = $this->Ctb27200Factory->getNrseqLalurb($row);
            }else{
                $row['NRSEQLALURB'] = $this->Ctb27200Factory->getNrseqLalurb($row);
            }
            $UpdateLancParteA = $this->Ctb27200Factory->acmUpdateLancParteA($row);
            $adqDadosParteB = $this->adqDadosParteB($row);
            if($adqDadosParteB == false){
                $adqDadosParteB = array();
                $adqDadosParteB['DTLIMITEUSO']  = null;
            }
            $adqDadosParteA = $this->adqDadosParteA($row);
            $acmInsertLalurParteB = $this->Ctb27200Factory->getAcmInsertLalurParteB($adqDadosParteA, $pVRDEBITO, $pVRCREDITO, $row, $adqDadosParteB);
            $this->Ctb27200Factory->execSaldoLalurParteB($row['CDEMPRESA'], $row['CDCONTCTBL']);
		} catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function apagaParteB($row){
        try{
            $adqDadosParteB = $this->adqDadosParteB($row);
            $adqDadosParteA = $this->adqDadosParteA($row);
            if(!empty($adqDadosParteB)){
                $acmDelLalurParteB = $this->Ctb27200Factory->getAcmDelLalurParteB($row);
            }
            
            //$this->atualizaParteB($row['CDEMPRESA'], '', 'N', $adqDadosParteA['CDCONTCTBLB']);
         }catch (\Exception $e) {
            throw $e;
        }
    }

    public function atualizaSaldoParteB($cdempresa, $nrseqlalura, $apagaantigo, $cdcontctbl){
        try{
            if($apagaantigo == 'S'){
                $this->apagaParteB($cdempresa, $nrseqlalura);
            }else{
                $stpSaldoLalur = $this->Ctb27200Factory->execSaldoLalurParteB($cdempresa, $cdcontctbl);
            }
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function adqDadosParteB($row){
        try{
            $adqDadosParteB = $this->Ctb27200Factory->getAdqDadosParteB(array(
                    "P_CDEMPRESA" => $row['CDEMPRESA'],
                    "P_NRSEQLALURA" => $row['NRSEQLALURA']
                ));
            return $adqDadosParteB;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function adqContasLancParteA($row){
        try{
            $nrseqlalura = $row['NRSEQLALURA'];
            $adqLancamentosContas = $this->Ctb27200Factory->adqContasLancParteA($nrseqlalura);
            return $adqLancamentosContas;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function adqDadosParteA($row){
        try {
            $adqDadosParteA = $this->Ctb27200Factory->getAdqDadosParteA(array(
                    "P_CDEMPRESA" => $row['CDEMPRESA'],
                    "P_NRSEQLALURA" => $row['NRSEQLALURA']
                ));
            return $adqDadosParteA;
            
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function acmInsertLalurParteB($row){
        try {
            $acmInsertLalurParteB = $this->Ctb27200Factory->getAcmInsertLalurParteB(array(
                "P_CDEMPRESA" => $row['CDEMPRESA'],
                "P_NRSEQLALURA" => $row['NRSEQLALURA']
            ));
            
        }catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function validaHistorico($row){
        try {
            return $selectHistorico = $this->Ctb27200Factory->getHistoricoLancamento(
                $row['CDEMPRESA'], $row['DTLANCCONT'], $row['CDCONTCTBL']
            );
            
        }catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function deleteLancamentos($row){
        
        
        //atualizando saldos 
        $conta = $this->Ctb27200Factory->getContaByNRSEQCONTLALURA($row);
        if($row['IDTIPO'] == 'DB'){
            $row['VRLANCAMENT'] = -1*$row['VRLANCAMENT'];
        }
        $adqDadosParteA = $this->adqDadosParteA($conta);
        $adqDadosParteA['VRLANCAMENT'] -= $row['VRCDCONTCTBL'];
        $this->Ctb27200Factory->acmUpdateLancParteA($adqDadosParteA);
        $this->ckcAtualizaSaldoParteB($adqDadosParteA);
        
        //exclui lançamentos da conta
        $this->Ctb27200Factory->acmExcluiLancamentosConta($row);
        
        //exclui conta
        $this->Ctb27200Factory->acmDeleteContasLancParteA($row);
    }
    
    public function insertLancContasAuto($row){
        $row['NRORG'] = $this->environment->getNrOrgTrab();
        
        $VALORFINALCONTA = $this->Ctb27200Factory->insertLancContasAuto($row);
        $row['VRCDCONTCTBL'] = $VALORFINALCONTA;
        $this->Ctb27200Factory->acmUpdateContasLancParteA($row);
        
        $conta = $this->Ctb27200Factory->getContaByNRSEQCONTLALURA($row);
        
        $adqDadosParteA = $this->adqDadosParteA($conta);
        $adqDadosParteA['VRLANCAMENT'] += $VALORFINALCONTA;
        $this->Ctb27200Factory->acmUpdateLancParteA($adqDadosParteA);
        $this->ckcAtualizaSaldoParteB($adqDadosParteA);

    }
    
    public function deleteLancContabeisEnvolvidos($row){
        $row['NRORG'] = $this->environment->getNrOrgTrab();
        
        //deletando
        $this->Ctb27200Factory->deleteLancContabeisEnvolvidos($row);
        
        //atualizando saldos 
        if($row['IDTIPO'] == 'DB'){
            $row['VRLANCAMENT'] = -1*$row['VRLANCAMENT'];
        }
        $conta = $this->Ctb27200Factory->getContaByNRSEQCONTLALURA($row);
        
        $conta['VRCDCONTCTBL'] -= $row['VRLANCAMENT'];
        $this->Ctb27200Factory->acmUpdateContasLancParteA($conta);
        
        $adqDadosParteA = $this->adqDadosParteA($conta);
        $adqDadosParteA['VRLANCAMENT'] -= $row['VRLANCAMENT'];
        $this->Ctb27200Factory->acmUpdateLancParteA($adqDadosParteA);
        $this->ckcAtualizaSaldoParteB($adqDadosParteA);

    }
    
        
    public function salvarImportacaoTabelas($row){
        try{
            if($row['IDTRIBUTO_IMPORT'] == 'C'){
                $row['TABLE'] = 'M350A_LACS';
            }else{
                $row['TABLE'] = 'M300A_LALURA';
            }
            $this->Ctb27200Factory->deleteTabelaImportada($row);
    
            $file = $this->decodeFile($row['UPLOADFILE'][0]["b64File"]);
            $fileLines = $this->returnStringInlines($file);
            foreach ($fileLines as $lineNumber => $line) {
                if($lineNumber >0 && $line != ''){
                    // a os atributos são separados por | na linha 
                    $line = explode('|', $line);
                    $receitaItem = [];
                    $receitaItem['TABLE']       = $row['TABLE'];
                    $receitaItem['CDLANCAMENT'] = $line[0];
                    $receitaItem['DSLANCAMENT'] = $line[1];
                    $receitaItem['DTINICIO']    = $line[2];
                    $receitaItem['DTFIM']       = $line[3];
                    $receitaItem['DSFORMULA']   = $line[8];
                    $receitaItem['IDTIPOLANC']  = $line[9];
                    $this->Ctb27200Factory->salvarTabelaImportada($receitaItem);
                }
            }
        }    
        catch (\Exception $e) {
            throw (new \Exception("Erro ao ler arquivo : ". $e->getMessage(), 500));
        }
    }
    /**
     * Essa função tem como finalidade receber uma string que contém quebras de linhas,
     * e retornar em um array as linhas, onde cada posição do array contém uma linha da
     * string lida.
     *
     * @param $file | string completa com quebras de linha
     *
     * @return $file | array de strings, onde cada posição é uma linha
     */
    public function returnStringInlines($file) {
        $file = preg_split('/\R/', $file);
        return $file;
    }
    /**
     * Essa função tem como finalidade receber uma string codificada em base 64 e
     * descidificala para ser usada nas funções dessa classe.
     *
     * @param  string $encodedFile codificada em base64
     * @return string              decodificada
     */
    public function decodeFile($encodedFile) {
        $file = utf8_encode(base64_decode($encodedFile));
        return $file;
    }
}